<template>
  <button type="button" id="btn-submit" :class="[$style.btn, computedClass]" @click="$emit('click')">
    <span v-if="!loading">
      <slot></slot>
    </span>
    <span v-else>
      <svg class="animate-spin mx-auto h-5 w-5" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24">
        <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="4"></circle>
        <path
          class="opacity-75"
          fill="currentColor"
          d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"
        ></path>
      </svg>
    </span>
  </button>
</template>

<script>
import Style from '@/assets/scss/components/_button.module.scss';

export default {
  name: 'MeButtonDispatch',
  props: {
    variant: {
      type: String,
      default: 'yellow',
      validator: value => {
         return ['yellow', 'green', 'red', 'white'].indexOf(value) !== -1
      }
    },
    loading: {
      type: Boolean,
      default: false,
    },
    outline: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    $style() {
      return Style;
    },
    computedClass() {
      const variantName = this.variant.charAt(0).toUpperCase() + this.variant.slice(1);
      const variant = `btn${variantName}`;
      const outline = `btnOutline${variantName}`;
      return [`${this.outline ? this.$style[outline] : this.$style[variant]}`];
    },
  },
};
</script>